/*
 * Example: character manipulation
 * Copyright (C) 2000 Leandro Bernsmller
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */



#include <stdio.h>
#include "../../../include/base.h"



#define LETTER 0
#define DIGIT 1
#define ALPHANUMERIC 2



int main ()
{
	class_char ch;
	class_chclass_table ct;
	ct.init ();
	ct.set_max_enumerations (4);
	ct.add_enumeration ('A', 'Z', LETTER);
	ct.add_enumeration ('0', '9', DIGIT);
	ct.add_enumeration ('A', 'Z', ALPHANUMERIC);
	ct.add_enumeration ('0', '9', ALPHANUMERIC);

	ch.set ('A');
	printf ("character: '%c'  is letter: %d, is digit: %d, is alphanumeric: %d\n", ch.get (),
	        ct.match ('A', LETTER), 
					ct.match ('A', DIGIT),
					ct.match ('A', ALPHANUMERIC));

	ch.set ('1');
	printf ("character: '%c'  is letter: %d, is digit: %d, is alphanumeric: %d\n", ch.get (),
	        ct.match ('1', LETTER), 
					ct.match ('1', DIGIT),
					ct.match ('1', ALPHANUMERIC));
}
