/*
 * Example: history reporting.
 * Copyright (C) 1999  Leandro Bernsmller
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */



#include <stdio.h>
#include "../../../include/base.h"



int main ()
{
	// predefine messages

	class_history hist;

	hist.predefine_data ( "file-not-found", (DATAPT) "file was not found." );
	hist.predefine_data ( "memory-low", (DATAPT) "there is not enough memory." );
	hist.predefine_data ( "io-error", (DATAPT) "fail to access device." );

	char* predef;
	BOOL res = hist.get_predefined_data ( "memory-low", put_in predef );
	if ( !res )
	  printf ("Data not found!\n");
	else
	  printf ("predefined TEST message: %s\n", predef );

	// add entries in history

	char *msg = "history test, the messages are only tests.";
	hist.update ( "text", get_from msg, TRUE );

	int code = 10;
	hist.update ( "code", get_from code, TRUE );

	// get one predefined data and insert in history
	res = hist.get_predefined_data ( "file-not-found", put_in msg );
	if ( !res )
	  printf ("Data not found!\n");
	else
	  hist.update ( "text", get_from msg, FALSE );

	// get other predefined data and insert in history
	res = hist.get_predefined_data ( "io-error", put_in msg );
	if ( !res )
	  printf ("Data not found!\n");
	else
	  hist.update ( "text", get_from msg, FALSE );

	// get more one predefined data and insert in history
	res = hist.get_predefined_data ( "memory-low", put_in msg );
	if ( !res )
	  printf ("Data not found!\n");
	else
	  hist.update ( "text", get_from msg, FALSE );

	// show code label contents
	long int hcode = 0;
	hist.get_entry ( 0, "code", FALSE, hcode );
	printf ( "code: %d\n", (int) hcode );

	// show text entries
		
	BOOL end = FALSE;
	DWORD index = 0;
	while ( !end ) {

	  char* str = 00;
	  char* label = hist.get_entry ( index, "text", FALSE, put_in str );
	  
	  // if have found one entry
	  if ( label ) {
	    printf ("MESSAGE: %s\n", str );
	    index ++;
	  }
	  else
	    end = TRUE;
	}

	// empty history

	hist.terminate ();
}
