/*
 * Declare trans.cc
 * See source file for details.
 */



#ifndef __SBASE_TRANS_H__
#define __SBASE_TRANS_H__



// symbol read information
struct symbol_info {
  class_char obj;          // the symbol
  class_chclass_table* ct; // table with character classes
  DWORD posx;              // position in line (start with 0)
  DWORD posy;              // line position in input stream (start with 0)
};



class class_translator {

  public:

  class_translator ();
  ~class_translator ();

  private:

  // components which recognize input (organizers)
  class_multiparser m_recogs;
  // list (like a stack) of structured (non-atomic) components
  class_list m_structs;

  public:

  void  init ();
  void  terminate (class_enviroment*, class_sbase_history*);
  BOOL add_type (char*, class_component*);
  BOOL push_structure (class_component*);
  class_component* pop_structure ();
  class_component* get_processed_token (DATAPT, class_enviroment*, class_sbase_history*, BOOL*, BOOL*);
  BOOL parse_symbol (symbol_info*, class_enviroment*, class_sbase_history*, class_component**);
  class_component* translate_input (FILE*, class_chclass_table*, class_enviroment*, class_sbase_history*);
};



// end declarations
#endif
