/*
 * Script interpreter - makes runtime component activation.
 *
 * LICENSE:
 *
 * Copyright (C) 2000 Leandro Bernsmller
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */



#include "../../include/base.h"
#include "../../include/sbase/def.h"
#include "../../include/sbase/shistory.h"
#include "../../include/sbase/env.h"
#include "../../include/sbase/comp.h"
#include "../../include/sbase/sexec.h"



class_executor::class_executor ()
{
        init ();
}



class_executor::~class_executor ()
{
}



void  class_executor::
init ()
{
}



/*
 * Terminate script and enviroment.
 */
void  class_executor::
terminate (class_enviroment* env, class_sbase_history* hist)
{
}



/*
 * Interpret the given component.
 * env - the enviroment (name table)
 * hist - the history
 * int_comp - component to interpret
 *
 * return:
 * res_comp - the component returned in last component activation
 */
void class_executor::
interpret (class_enviroment *env,
           class_sbase_history *hist,
	   class_component *int_comp,
	   class_component **res_comp)
{
  *res_comp = (class_component *) int_comp->call (INVOKE, env, hist, 00);
}



/*
 * Show a textual representation of the given script.
 * env - the enviroment (name table)
 * hist - the history
 * int_comp - component to view text representation
 */
void class_executor::
show (class_enviroment* env, class_sbase_history* hist,	class_component* int_comp)
{
  class_string *str = (class_string *) int_comp->call (BIN_GET_TEXT_REPRESENTATION, env, hist, 00);
  if (!str)
    printf ("\n(warning: no text representation)\n");
  else
    printf ("%s", str->get ());
}
